using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Diagnostics;
using System.Text;
using ClientControls;
using System.Threading;

namespace SpringClient
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class ClientMain : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.ListView ChatroomList;
		private System.Windows.Forms.ColumnHeader Chatroom;
		private System.Windows.Forms.ColumnHeader NumInside;
		private System.Windows.Forms.TabControl ChatTabs;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuFileConnect;
		private System.Windows.Forms.MenuItem menuFileDisconnect;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.TabPage tabBattleList;
		private System.Windows.Forms.MenuItem menuFileRegister;
		private System.Windows.Forms.MenuItem menuChatroomsCreateChat;
		private System.Windows.Forms.MenuItem menuChatroomsCloseChat;
		private System.Windows.Forms.MenuItem menuChatrooms;
		private System.Windows.Forms.ListView BattleList;
		private System.Windows.Forms.Splitter splitter2;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.MenuItem menuBattle;
		private System.Windows.Forms.MenuItem menuBattleHost;

		private BattleManager	battleMan = null;
		private System.Windows.Forms.ColumnHeader columnHeader3;
		private ChatroomManager	ChatMan = null;
		private System.Windows.Forms.MenuItem menuItemConfiguration;
		private System.Windows.Forms.ColumnHeader columnHeader4;
		private System.Windows.Forms.ColumnHeader columnHeader5;
		private System.Windows.Forms.ColumnHeader columnHeader6;

		private System.Threading.Timer  timer;

		public ClientMain()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			Global.connMan = new ConnectionManager();
			Global.PrimaryForm = this;

			ChatMan = new ChatroomManager(ChatTabs, ChatroomList);
			battleMan = new BattleManager(this, BattleList);

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(ClientMain));
			this.ChatroomList = new System.Windows.Forms.ListView();
			this.Chatroom = new System.Windows.Forms.ColumnHeader();
			this.NumInside = new System.Windows.Forms.ColumnHeader();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.ChatTabs = new System.Windows.Forms.TabControl();
			this.tabBattleList = new System.Windows.Forms.TabPage();
			this.panel1 = new System.Windows.Forms.Panel();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.BattleList = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader5 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuFileConnect = new System.Windows.Forms.MenuItem();
			this.menuFileDisconnect = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuFileRegister = new System.Windows.Forms.MenuItem();
			this.menuItemConfiguration = new System.Windows.Forms.MenuItem();
			this.menuChatrooms = new System.Windows.Forms.MenuItem();
			this.menuChatroomsCreateChat = new System.Windows.Forms.MenuItem();
			this.menuChatroomsCloseChat = new System.Windows.Forms.MenuItem();
			this.menuBattle = new System.Windows.Forms.MenuItem();
			this.menuBattleHost = new System.Windows.Forms.MenuItem();
			this.columnHeader6 = new System.Windows.Forms.ColumnHeader();
			this.ChatTabs.SuspendLayout();
			this.tabBattleList.SuspendLayout();
			this.SuspendLayout();
			// 
			// ChatroomList
			// 
			this.ChatroomList.AllowColumnReorder = true;
			this.ChatroomList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						   this.Chatroom,
																						   this.NumInside});
			this.ChatroomList.Dock = System.Windows.Forms.DockStyle.Top;
			this.ChatroomList.FullRowSelect = true;
			this.ChatroomList.Location = new System.Drawing.Point(0, 0);
			this.ChatroomList.MultiSelect = false;
			this.ChatroomList.Name = "ChatroomList";
			this.ChatroomList.Size = new System.Drawing.Size(624, 128);
			this.ChatroomList.TabIndex = 0;
			this.ChatroomList.View = System.Windows.Forms.View.Details;
			this.ChatroomList.DoubleClick += new System.EventHandler(this.ChatroomList_DoubleClick);
			// 
			// Chatroom
			// 
			this.Chatroom.Text = "Chatroom";
			this.Chatroom.Width = 62;
			// 
			// NumInside
			// 
			this.NumInside.Text = "# Inside";
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 128);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(624, 3);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// ChatTabs
			// 
			this.ChatTabs.Controls.Add(this.tabBattleList);
			this.ChatTabs.Dock = System.Windows.Forms.DockStyle.Fill;
			this.ChatTabs.Location = new System.Drawing.Point(0, 131);
			this.ChatTabs.Name = "ChatTabs";
			this.ChatTabs.SelectedIndex = 0;
			this.ChatTabs.Size = new System.Drawing.Size(624, 491);
			this.ChatTabs.TabIndex = 2;
			this.ChatTabs.SelectedIndexChanged += new System.EventHandler(this.ChatTabs_SelectedIndexChanged);
			// 
			// tabBattleList
			// 
			this.tabBattleList.Controls.Add(this.panel1);
			this.tabBattleList.Controls.Add(this.splitter2);
			this.tabBattleList.Controls.Add(this.BattleList);
			this.tabBattleList.Location = new System.Drawing.Point(4, 22);
			this.tabBattleList.Name = "tabBattleList";
			this.tabBattleList.Size = new System.Drawing.Size(616, 465);
			this.tabBattleList.TabIndex = 0;
			this.tabBattleList.Text = "Battles";
			// 
			// panel1
			// 
			this.panel1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.panel1.Location = new System.Drawing.Point(0, 459);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(616, 6);
			this.panel1.TabIndex = 2;
			// 
			// splitter2
			// 
			this.splitter2.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter2.Location = new System.Drawing.Point(0, 456);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(616, 3);
			this.splitter2.TabIndex = 1;
			this.splitter2.TabStop = false;
			// 
			// BattleList
			// 
			this.BattleList.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.columnHeader1,
																						 this.columnHeader2,
																						 this.columnHeader3,
																						 this.columnHeader5,
																						 this.columnHeader4,
																						 this.columnHeader6});
			this.BattleList.Dock = System.Windows.Forms.DockStyle.Top;
			this.BattleList.FullRowSelect = true;
			this.BattleList.Location = new System.Drawing.Point(0, 0);
			this.BattleList.Name = "BattleList";
			this.BattleList.Size = new System.Drawing.Size(616, 456);
			this.BattleList.TabIndex = 0;
			this.BattleList.View = System.Windows.Forms.View.Details;
			this.BattleList.DoubleClick += new System.EventHandler(this.BattleList_DoubleClick);
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Name";
			this.columnHeader1.Width = 80;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "Host";
			this.columnHeader2.Width = 80;
			// 
			// columnHeader3
			// 
			this.columnHeader3.Text = "Map";
			this.columnHeader3.Width = 80;
			// 
			// columnHeader5
			// 
			this.columnHeader5.Text = "Players";
			// 
			// columnHeader4
			// 
			this.columnHeader4.Text = "Password";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuFile,
																					  this.menuChatrooms,
																					  this.menuBattle});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuFileConnect,
																					 this.menuFileDisconnect,
																					 this.menuItem1,
																					 this.menuFileRegister,
																					 this.menuItemConfiguration});
			this.menuFile.Text = "File";
			// 
			// menuFileConnect
			// 
			this.menuFileConnect.Index = 0;
			this.menuFileConnect.Text = "&Connect";
			this.menuFileConnect.Click += new System.EventHandler(this.menuFileConnect_Click);
			// 
			// menuFileDisconnect
			// 
			this.menuFileDisconnect.Index = 1;
			this.menuFileDisconnect.Text = "&Disconnect";
			this.menuFileDisconnect.Visible = false;
			this.menuFileDisconnect.Click += new System.EventHandler(this.menuFileDisconnect_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 2;
			this.menuItem1.Text = "-";
			// 
			// menuFileRegister
			// 
			this.menuFileRegister.Index = 3;
			this.menuFileRegister.Text = "&Register";
			this.menuFileRegister.Click += new System.EventHandler(this.menuFileRegister_Click);
			// 
			// menuItemConfiguration
			// 
			this.menuItemConfiguration.Enabled = false;
			this.menuItemConfiguration.Index = 4;
			this.menuItemConfiguration.Text = "&Configuration";
			this.menuItemConfiguration.Click += new System.EventHandler(this.menuItemConfiguration_Click);
			// 
			// menuChatrooms
			// 
			this.menuChatrooms.Index = 1;
			this.menuChatrooms.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.menuChatroomsCreateChat,
																						  this.menuChatroomsCloseChat});
			this.menuChatrooms.Text = "Chatrooms";
			this.menuChatrooms.Visible = false;
			// 
			// menuChatroomsCreateChat
			// 
			this.menuChatroomsCreateChat.Index = 0;
			this.menuChatroomsCreateChat.Text = "Create Chat";
			this.menuChatroomsCreateChat.Click += new System.EventHandler(this.menuChatroomsCreateChat_Click);
			// 
			// menuChatroomsCloseChat
			// 
			this.menuChatroomsCloseChat.Enabled = false;
			this.menuChatroomsCloseChat.Index = 1;
			this.menuChatroomsCloseChat.Text = "&Close Chat";
			this.menuChatroomsCloseChat.Click += new System.EventHandler(this.menuFileCloseChat_Click);
			// 
			// menuBattle
			// 
			this.menuBattle.Index = 2;
			this.menuBattle.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuBattleHost});
			this.menuBattle.Text = "Battles";
			this.menuBattle.Visible = false;
			// 
			// menuBattleHost
			// 
			this.menuBattleHost.Index = 0;
			this.menuBattleHost.Text = "&Host";
			this.menuBattleHost.Click += new System.EventHandler(this.menuBattleHost_Click);
			// 
			// columnHeader6
			// 
			this.columnHeader6.Text = "In Game";
			// 
			// ClientMain
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(624, 622);
			this.Controls.Add(this.ChatTabs);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.ChatroomList);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "ClientMain";
			this.Text = "Spring Lobby - Not Connected";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.ClientMain_Closing);
			this.Load += new System.EventHandler(this.ClientMain_Load);
			this.ChatTabs.ResumeLayout(false);
			this.tabBattleList.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new ClientMain());
		}

		private void menuFileConnect_Click(object sender, System.EventArgs e)
		{
			try
			{
				Global.connMan.Connect(Global.ServerLoc, Global.ServerPort);
				if ( !Global.connMan.Connected )
				{
					MessageBox.Show("Could not connect to server", "Connection error");
					return;
				}

				bool keepgoing = true;
				Login loginbox = new Login();

				while ( keepgoing )
				{
					DialogResult res = loginbox.ShowDialog();
					if ( res == DialogResult.OK )
					{
						byte[] response = new byte[1];
						Global.connMan.Send(new byte[] {(byte)PACKETS.PACK_LOGIN, (byte)CONSTANTS.VERMAJOR, (byte)CONSTANTS.VERMINOR});
						byte[] NameBytes = Encoding.Default.GetBytes(loginbox.User.PadRight(CONSTANTS.MAXNAME, '\0'));
						byte[] PassBytes = Encoding.Default.GetBytes(loginbox.Pass.PadRight(CONSTANTS.MAXPASSWD, '\0'));
						Global.connMan.Send(NameBytes);
						Global.connMan.Send(PassBytes);
					
						Global.connMan.Read(response, 0, 1);
						byte[] reason = null;
						switch ( (PACKETS)response[0] )
						{
							case PACKETS.PACK_LOGGEDIN:
							{
								byte[] id = new byte[4+CONSTANTS.MAXNAME];
								Global.connMan.Read(id, 0, 4+CONSTANTS.MAXNAME);
								UserInfo.ID = BitConverter.ToInt32(id, 0);
								UserInfo.Name = Encoding.Default.GetString(id, 4, CONSTANTS.MAXNAME).TrimEnd("\0".ToCharArray());
								keepgoing = false;
								Connected();
							}
								break;
							case PACKETS.PACK_LOGINFAILED:
								reason = new byte[1];
								Global.connMan.Read(reason);
							switch ( (LOGINERROR)reason[0] )
							{
								case LOGINERROR.LOGINERROR_VERSION:
									MessageBox.Show("Client out of date.  Please update");
									break;
								case LOGINERROR.LOGINERROR_USER:
									MessageBox.Show("Login failed, user not found");
									break;
								case LOGINERROR.LOGINERROR_PASSWORD:
									MessageBox.Show("Login failed, wrong password");
									break;
								default:
									MessageBox.Show("Login failed, unknown error");
									break;
							}
								break;
							case PACKETS.PACK_BLOCKED:
								reason = new byte[1];
								Global.connMan.Read(reason);
							switch ( (LOGINERROR)reason[0] )
							{
								case LOGINERROR.LOGINERROR_VERSION:
									MessageBox.Show("Client out of date.  Please update");
									break;
								case LOGINERROR.LOGINERROR_USER:
									MessageBox.Show("Login failed, user not found.  Maximum log in attempts exceeded.");
									break;
								case LOGINERROR.LOGINERROR_PASSWORD:
									MessageBox.Show("Login failed, wrong password.  Maximum log in attempts exceeded.");
									break;
								default:
									MessageBox.Show("Login failed, unknown error.  Maximum log in attempts exceeded.");
									break;
							}
								keepgoing = false;
								break;
						}
					}
					else
						keepgoing = false;
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
		}

		public void DestroyBattleMessage(uint ID)
		{
			battleMan.DestroyBattle(ID);
		}

		public void BattleProgressMessage(uint ID, byte newstate )
		{
			battleMan.ProgressUpdate(ID, newstate);
		}

		public void Disconnected()
		{
			menuChatrooms.Visible = false;
			menuFileConnect.Visible = true;
			menuFileDisconnect.Visible = false;
			menuBattle.Visible = false;
			
			ChatMan.CloseAllChatrooms();
			ChatroomList.Items.Clear();
			UserInfo.LoggedIn = false;
			if ( timer != null )
			{
				timer.Dispose();
				timer = null;
			}
			menuItemConfiguration.Enabled = false;
//			timerServer.Stop();

			battleMan.Clear();
	
			if ( Global.battleRoom != null )
			{
				Global.battleRoom.Shutdown();
				Global.battleRoom.Close();
				Global.battleRoom = null;
			}

			this.Text = "Spring Lobby - Not Connected";
		}

		public void Connected()
		{
			menuFileConnect.Visible = false;
			menuFileDisconnect.Visible = true;
			menuChatrooms.Visible = true;
			menuBattle.Visible = true;
			UserInfo.LoggedIn = true;
			this.Text = string.Format("Spring Lobby - {0}", UserInfo.Name);
			Global.connMan.StartListener(this);
			menuItemConfiguration.Enabled = true;
			Configuration.GetConfiguration();
			//		timer = new System.Threading.Timer(new TimerCallback(timerCallback), null, 4000, 4000);
			
//			timerServer.Start();
		}

		private void ClientMain_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if ( Global.battleRoom != null )
			{
				Global.battleRoom.Shutdown();
				Global.battleRoom.Close();
			}
			if ( Global.connMan != null )
				Global.connMan.Disconnect();
		}

		private void menuFileDisconnect_Click(object sender, System.EventArgs e)
		{
			// then kill the connection
			Global.connMan.Disconnect();
			Disconnected();
		}

		public void AddChat(string name, int id, short size)
		{
			ListViewItem lvi = new ListViewItem(new string[] {name, size.ToString(), id.ToString()}, -1);
			ChatroomList.Items.Add(lvi);
		}

		public void UpdateChatSize(int id, short size)
		{
			foreach ( ListViewItem lvi in ChatroomList.Items )
			{
				if ( lvi.SubItems[2].Text == id.ToString() )
				{
					lvi.SubItems[1].Text = size.ToString();
					break;
				}
			}
		}

		public void PostChatMessage(int chatid, int userid, string message)
		{
			ChatMan.ChatMessagePost(userid, chatid, message);
		}

		public void UserChatAdd(int chatid, int userid, string name, string clan, bool notify)
		{
			ChatMan.AddUserToChatroom(chatid, userid, name, clan, notify);
		}

		public void AddBattle(BattleHostInfo bhi)
		{
			battleMan.CreateBattle(bhi);
		}

		public void RemoveChat(int id)
		{
			foreach ( ListViewItem lvi in ChatroomList.Items )
			{
				if ( Convert.ToInt32(lvi.SubItems[2].Text) == id )
				{
					ChatroomList.Items.Remove(lvi);
					break;
				}
			}
		}

		public void EnterChat(int id)
		{
			string name = "";
			foreach ( ListViewItem lvi in ChatroomList.Items )
			{
				if ( id == Convert.ToInt32(lvi.SubItems[2].Text) )
				{
					name = lvi.SubItems[0].Text;
				}
			}
			ChatMan.EnterChatroom(id, name);
		}

		public void UserChatRemove(int chatid, int userid)
		{
			ChatMan.RemoveUserFromChatroom(chatid, userid);
		}

		public void HostBattle(uint ID, ushort port, string mapname, byte password, byte maxplayers)
		{
			Global.battleRoom = new BattleRoom(this, ID, (int)port, true, false, Global.connMan, 0, maxplayers);
			Global.battleRoom.SetMap(string.Format("{0}\\maps\\{1}.sm2", Global.SpringDirectory, mapname), mapname);
			Global.battleRoom.Show();
			if ( password != 0 )
				Global.battleRoom.SetPassword(Global.BattleRoomPassword);
		}

		public void SendDestroyBattleMessageCallback(uint ID)
		{
			Global.connMan.Send((byte)PACKETS.PACK_DESTROYBATTLE);
			Global.connMan.Send(ID);
		}

		private void ChatroomList_DoubleClick(object sender, System.EventArgs e)
		{
			ListView ls = (ListView)sender;
			ListView.SelectedListViewItemCollection slvic = ls.SelectedItems;
			foreach ( ListViewItem lvi in slvic )
			{
				ChatMan.RequestEnterChatroom(lvi);
			}
		}

		private void menuFileCloseChat_Click(object sender, System.EventArgs e)
		{
			string name = ChatTabs.SelectedTab.Text;
			int index = -1;
			foreach ( ListViewItem lvi in ChatroomList.Items )
			{
				if ( name == lvi.SubItems[0].Text )
				{
					index = Convert.ToInt32(lvi.SubItems[2].Text);
					break;
				}
			}
			if ( index == -1 || index == 0 )
			{
				MessageBox.Show("Error closing chat tab.  Bad bug!", "Error");
				return;
			}
			ChatMan.LeaveChatroom(index);
		}

		private void ChatTabs_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if ( ((TabControl)sender).TabCount == 1 || ((TabControl)sender).SelectedTab.Name == "tabBattleList" )
			{
				menuChatroomsCloseChat.Enabled = false;
			}
			else
				menuChatroomsCloseChat.Enabled = true;
		}

		private void menuFileRegister_Click(object sender, System.EventArgs e)
		{
			try
			{
				Global.connMan.Connect(Global.ServerLoc, Global.ServerPort);
				if ( !Global.connMan.Connected )
				{
					MessageBox.Show("Could not connect to server", "Connection error");
					return;
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}

			try
			{				
				Register regWindow = new Register();
				if ( regWindow.ShowDialog() == DialogResult.OK )
				{
					byte[] userNameBytes = Encoding.Default.GetBytes(regWindow.Username.PadRight(CONSTANTS.MAXNAME, '\0'));
					byte[] userNameFormattingBytes = Encoding.Default.GetBytes(regWindow.NameFormatted.PadRight(CONSTANTS.MAXNAME, '\0'));
					byte[] passwordBytes = Encoding.Default.GetBytes(regWindow.Password.PadRight(CONSTANTS.MAXPASSWD, '\0'));

					byte[] msg = new byte[1];

					// now attempt to register
					Global.connMan.Send((byte)PACKETS.PACK_REGISTER);
					Global.connMan.Send(userNameBytes);
					Global.connMan.Send(userNameFormattingBytes);
					Global.connMan.Send(passwordBytes);

					Global.connMan.Read(msg);
					switch ( (PACKETS)msg[0] )
					{
						case PACKETS.PACK_REGISTERSUCCESS:
							MessageBox.Show("Registration successful", "Registration");
							break;
						case PACKETS.PACK_REGISTERFAILED:
							Global.connMan.Read(msg);
						switch ( (PACKASSIST)msg[0] )
						{
							case PACKASSIST.REGISTER_USEREXISTS:
								MessageBox.Show("User exists.  Try another name", "Registration failed");
								break;
							case PACKASSIST.REGISTER_BADPASSWORD:
								MessageBox.Show("Password must only have alphanumeric characters", "Registration failed");
								break;
							case PACKASSIST.REGISTER_BADUSERNAME:
								MessageBox.Show("Username must only have alphanumeric characters", "Registration failed");
								break;
							case PACKASSIST.REGISTER_FORMATMISMATCH:
								MessageBox.Show("Format does not match up with the user name.", "Registration failed");
								break;
							case PACKASSIST.REGISTER_GENERIC:
								MessageBox.Show("Generic error.  Try again.", "Registration failed");
								break;
							default:
								throw new Exception("Bad assist packet");
						}
							break;
						default:
							throw new Exception("Bad message");
					}
				}
			}
			catch ( Exception ex )
			{
				MessageBox.Show(ex.ToString());
			}
			finally
			{
				Global.connMan.Disconnect();
			}
		}

		private void menuChatroomsCreateChat_Click(object sender, System.EventArgs e)
		{
			ChatCreate ccWindow = new ChatCreate();
			if ( DialogResult.OK == ccWindow.ShowDialog() )
			{
				byte[] msg = new byte[1];
				msg[0] = (byte)PACKETS.PACK_CREATECHAT;
				StringBuilder chatname = new StringBuilder(ccWindow.ChatName, CONSTANTS.MAXCHATNAME);
				while ( chatname.Length < CONSTANTS.MAXCHATNAME )
					chatname.Append('\0');
				Global.connMan.Send(msg);
				Global.connMan.Send(chatname.ToString());
			}
		}

		private void BattleList_DoubleClick(object sender, System.EventArgs e)
		{
			ListView ls = (ListView)sender;
			ListView.SelectedListViewItemCollection slvic = ls.SelectedItems;
			foreach ( ListViewItem lvi in slvic )
			{
				battleMan.JoinBattle(lvi);
			}
		}

		private void menuBattleHost_Click(object sender, System.EventArgs e)
		{
			BattleHost bh = new BattleHost();
			if ( DialogResult.OK == bh.ShowDialog() )
			{
				StringBuilder sb = new StringBuilder(bh.BattleName, CONSTANTS.MAXBATTLENAME);
//				StringBuilder sb = new StringBuilder("asda", CONSTANTS.MAXBATTLENAME);
				
				while ( sb.Length < CONSTANTS.MAXBATTLENAME )
					sb.Append('\0');
				Global.connMan.Send((byte)PACKETS.PACK_CREATEBATTLE);
				Global.connMan.Send(Encoding.Default.GetBytes(sb.ToString()));
				Global.connMan.Send((byte)bh.MaxPlayers);
//				Global.connMan.Send((byte)5);
				Global.connMan.Send((ushort)bh.Port);
//				Global.connMan.Send(Encoding.Default.GetBytes("map4".PadRight(CONSTANTS.MAXMAPNAME, '\0')));
				Global.connMan.Send(Encoding.Default.GetBytes(bh.Mapname.PadRight(CONSTANTS.MAXMAPNAME, '\0')));
//				string mapname = bh.Mapname.Substring(bh.Mapname.LastIndexOf("\\".ToString())+1);
				Global.BattleRoomPassword = bh.Password;
				if ( bh.Password.Length == 0 )
					Global.connMan.Send((byte)0);
				else
					Global.connMan.Send((byte)1);
			}
		}

		private void timerCallback ( object state )
		{
			try
			{
				lock ( Global.connMan )
				{
					if ( Global.connMan == null || !Global.connMan.Connected )
					{
						Disconnected();
					}
					else
						Global.connMan.Send((byte)PACKETS.PACK_KEEPALIVE);
				}
			}
			catch ( System.Net.Sockets.SocketException )
			{
				Disconnected();
			}
			catch ( Exception ex )
			{
				Disconnected();
				MessageBox.Show(ex.ToString());
			}
		}

		private void ClientMain_Load(object sender, System.EventArgs e)
		{
//			ClientControls.UnitSync.Test();
			System.Diagnostics.Debug.WriteLine(string.Format("BLAH {0}", System.Diagnostics.Process.GetCurrentProcess().Threads.Count));
	//		MessageBox.Show(System.IO.Directory.GetCurrentDirectory());
		}

		private void menuItemConfiguration_Click(object sender, System.EventArgs e)
		{
			Configuration config = new Configuration();
			config.ShowDialog();
		}

		public void MapUpdate(uint id, string newname)
		{
			battleMan.MapUpdate(id, newname);
		}

		public void BattleSizeUpdate(uint id, byte size)
		{
			battleMan.SizeUpdate(id, size);
		}
	}
}
